From 506bcc57d67616a8bbe606736bbb54c1314b1655 Mon Sep 17 00:00:00 2001
From: Alexey Min <alexey.min@gmail.com>
Date: Fri, 29 Jan 2021 12:17:48 +0300
Subject: [PATCH 44/59] AlpineApkBackend: use AppstreamDataDownloader

Download AppStream data from external URLs after
loading resources initially. Reload AppStream
metadata after download has finished.

Refactor resource loading process into several
subroutines for easier understanding and code sharing.
---
 .../AlpineApkBackend/AlpineApkBackend.cpp     | 166 +++++++++++++-----
 .../AlpineApkBackend/AlpineApkBackend.h       |  10 +-
 2 files changed, 131 insertions(+), 45 deletions(-)

diff --git a/libdiscover/backends/AlpineApkBackend/AlpineApkBackend.h b/libdiscover/backends/AlpineApkBackend/AlpineApkBackend.h
index 2ec8b00b6..07b6b7be8 100644
--- a/libdiscover/backends/AlpineApkBackend/AlpineApkBackend.h
+++ b/libdiscover/backends/AlpineApkBackend/AlpineApkBackend.h
@@ -22,8 +22,9 @@
 #define AlpineApkBackend_H
 
 #include <resources/AbstractResourcesBackend.h>
-#include <QVariantList>
+
 #include <QFutureWatcher>
+#include <QVariantList>
 
 #include <QtApk>
 
@@ -32,6 +33,7 @@
 class AlpineApkReviewsBackend;
 class AlpineApkUpdater;
 class AlpineApkResource;
+class AppstreamDataDownloader;
 class KJob;
 class QTimer;
 
@@ -66,8 +68,13 @@ public Q_SLOTS:
 
 private Q_SLOTS:
     void finishCheckForUpdates();
+    void loadAppStreamComponents();
+    void parseAppStreamMetadata();
+    void reloadAppStreamMetadata();
+    void fillResourcesAndApplyAppStreamData();
     void loadResources();
     void onLoadResourcesFinished();
+    void onAppstreamDataDownloaded();
 
 public:
     QtApk::Database *apkdb() { return &m_apkdb; }
@@ -86,6 +93,7 @@ private:
     QList<AppStream::Component> m_appStreamComponents;
     // QVector<QString> m_collectedCategories;
     QFutureWatcher<void> m_voidFutureWatcher;
+    AppstreamDataDownloader *m_appstreamDownloader;
 };
 
 #endif // AlpineApkBackend_H
-- 
GitLab


